#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <math.h>
#include "arduinolib.h"

#define FOCUS_MIN	173
#define FOCUS_MAX	724
#define ZOOM_MIN	173
#define ZOOM_MAX	724
//objective range 12 -120 mm
#define OBJECTIVE_MIN	12
#define OBJECTIVE_MAX	120

#define ZOOM_FOCUS_VALUE_PER_OBJECTIVE_STEP   (ZOOM_MAX - ZOOM_MIN)/(OBJECTIVE_MAX -OBJECTIVE_MIN)


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

        connect(ui->pushButton, SIGNAL(clicked()), this, SLOT(setObjectiveFocus()));
        connect(ui->pushButton_2, SIGNAL(clicked()), this, SLOT(setObjectiveZoom()));
        connect(ui->pushButton_3, SIGNAL(clicked()), this, SLOT( manipulateObjective()));
        connect(ui->pushButton_4, SIGNAL(clicked()), this, SLOT( doAutoFocus()));
        connect(ui->pushButton_5, SIGNAL(clicked()), this, SLOT( doMovePtuUp()));
        connect(ui->pushButton_6, SIGNAL(clicked()), this, SLOT( doMovePtuDown()));
        connect(ui->pushButton_7, SIGNAL(clicked()), this, SLOT( doMovePtuLeft()));
        connect(ui->pushButton_8, SIGNAL(clicked()), this, SLOT( doMovePtuRight()));


        createConnectionToArduino("134.100.13.166", 8888);

}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::setObjectiveFocus(void)
{
  setFocusToMm(ui->lineEdit->text().toInt());
  getObjectiveFocusZoom();
}

void MainWindow::setObjectiveZoom(void)
{
  setZoomToMm(ui->lineEdit->text().toInt());
  getObjectiveFocusZoom();
}

void MainWindow::manipulateObjective(void)
{
     int *getZoomFocus ;
     getZoomFocus= getAnalogValues();//getZoomFocus[0]=Focus;getZoomFocus[1]=Zoom

     if(ui->radioButton->isChecked())
     {setZoomToMm( 1 + ((int) round((getZoomFocus[1]-(ZOOM_MIN - 12*5.055045872 ))/5.055045872)))  ;
     }
     if(ui->radioButton_2->isChecked())
     {setZoomToMm( 5 + ((int) round((getZoomFocus[1]-(ZOOM_MIN - 12*5.055045872 ))/5.055045872)))  ;}
     if(ui->radioButton_3->isChecked())
     {setZoomToMm( 20 + ((int) round((getZoomFocus[1]-(ZOOM_MIN - 12*5.055045872 ))/5.055045872)))  ; }
     if(ui->radioButton_4->isChecked())
     {setZoomToMm( -1 + ((int) round((getZoomFocus[1]-(ZOOM_MIN - 12*5.055045872 ))/5.055045872)))  ; }
     if(ui->radioButton_5->isChecked())
     {setZoomToMm( -5 + ((int) round((getZoomFocus[1]-(ZOOM_MIN - 12*5.055045872 ))/5.055045872)))  ; }
     if(ui->radioButton_6->isChecked())
     {setZoomToMm( -20 + ((int) round((getZoomFocus[1]-(ZOOM_MIN - 12*5.055045872 ))/5.055045872)))  ; }

     if(ui->radioButton_9->isChecked())
     {setFocusToMm( 1 + ((int) round((getZoomFocus[0]-(FOCUS_MIN - 12*5.055045872 ))/5.055045872)))  ; }
     if(ui->radioButton_10->isChecked())
     {setFocusToMm( 5 + ((int) round((getZoomFocus[0]-(FOCUS_MIN - 12*5.055045872 ))/5.055045872)))  ; }
     if(ui->radioButton_11->isChecked())
     {setFocusToMm( 20 + ((int) round((getZoomFocus[0]-(FOCUS_MIN - 12*5.055045872 ))/5.055045872)))  ; }
     if(ui->radioButton_12->isChecked())
     {setFocusToMm( -1 + ((int) round((getZoomFocus[0]-(FOCUS_MIN - 12*5.055045872 ))/5.055045872)))  ; }
     if(ui->radioButton_13->isChecked())
     {setFocusToMm( -5 + ((int) round((getZoomFocus[0]-(FOCUS_MIN - 12*5.055045872 ))/5.055045872)))  ; ;}
     if(ui->radioButton_14->isChecked())
     {setFocusToMm( -20 + ((int) round((getZoomFocus[0]-(FOCUS_MIN - 12*5.055045872 ))/5.055045872)))  ; }

     getObjectiveFocusZoom();
}


//todo refactoring
void MainWindow::getObjectiveFocusZoom(void)
{
    int *a ;
     a= getAnalogValues();
    char strf[10];
    char strz[10];
    sprintf(strf,"%d",a[0]);
    sprintf(strz,"%d",a[1]);
    char strff[10];
    char strzz[10];
    sprintf(strff,"%d",(int) round((a[0]-(FOCUS_MIN - 12*5.055045872 ))/5.055045872));
    sprintf(strzz,"%d",(int) round((a[1]-(ZOOM_MIN - 12*5.055045872 ))/5.055045872));

 ui->textBrowser->clear();
 ui->textBrowser->append("Focus: ");
 ui->textBrowser->append(strf);
 ui->textBrowser->append(strff);

 ui->textBrowser->append("Zoom: ");
 ui->textBrowser->append(strz);
 ui->textBrowser->append(strzz);
}

void MainWindow::doAutoFocus(void)
{
autoFocus();
}

void MainWindow::doMovePtuUp(void)
{
    movePtu(UP,ui->lineEdit_2->text().toInt());

}
void MainWindow::doMovePtuDown(void)
{
    movePtu(DOWN,ui->lineEdit_2->text().toInt());

}

void MainWindow::doMovePtuLeft(void)
{
    movePtu(LEFT,ui->lineEdit_2->text().toInt());

}

void MainWindow::doMovePtuRight(void)
{
    movePtu(RIGHT,ui->lineEdit_2->text().toInt());

}
