__constant sampler_t samp = CLK_NORMALIZED_COORDS_FALSE | CLK_ADDRESS_CLAMP | CLK_FILTER_NEAREST;
__constant sampler_t sampf = CLK_NORMALIZED_COORDS_FALSE |CLK_ADDRESS_CLAMP | CLK_FILTER_LINEAR;
__kernel void rgbargba(__read_only image2d_t in, __write_only image2d_t out)
//__kernel void rgbargba(__global const image2d_t in,__global image2d_t out)
{

size_t x=get_global_id(0),y=get_global_id(1); // upper-left corner of this work-item tile 
size_t xmax=get_global_size(0),ymax=get_global_size(1);
//size_t nx=get_local_size(0),ny=get_local_size(1);
int2 xycoords={x,y};
if ((x==0)||(x==xmax)||(y==0)||(y==ymax)){
  write_imageui(out, xycoords, (0,0,0,0));
  return;
}
// resample each pixel in this work-item's tile
//for (int ii=0; ii<nx; ++ii) {
//  for (int jj=0; jj<ny; ++jj) {
   // int2 xycoords={x+ii,y+jj};
    //int2 xycoords={x,y};
    // read xmap and ymap 
    // warping -read from input and write into output 
    int2 reader={x-1,y-1};
    uint4 pixel1=read_imageui(in, samp, reader); 
    reader.x=reader.x+1;
    uint4 pixel2=read_imageui(in, samp, reader);
    reader.x=reader.x+1;
    uint4 pixel3=read_imageui(in, samp, reader);
    reader.x=reader.x-2;
    reader.y=reader.y+1;
    uint4 pixel4=read_imageui(in, samp, reader); 
    reader.x=reader.x+1;
    uint4 pixel5=read_imageui(in, samp, reader);
    reader.x=reader.x+1;
    uint4 pixel6=read_imageui(in, samp, reader);
    reader.x=reader.x-2;
    reader.y=reader.y+1;
    uint4 pixel7=read_imageui(in, samp, reader); 
    reader.x=reader.x+1;
    uint4 pixel8=read_imageui(in, samp, reader);
    reader.x=reader.x+1;
    uint4 pixel9=read_imageui(in, samp, reader);
    
    //uint4 outpix=(4*pixel5)-pixel2-pixel4-pixel6-pixel8;this is laplace
    //now the sobel
    uint4 vert=pixel1-pixel3+(2*pixel4)-(2*pixel6)+pixel7-pixel9;
    uint4 hor=pixel1+(2*pixel2)+pixel3-pixel7-(2*pixel8)-pixel9;
    uint4 outpix=((vert*vert)+(hor*hor));
    outpix.x=(int)(sqrt((float)outpix.x));
    outpix.y=(int)(sqrt((float)outpix.y));
    outpix.z=(int)(sqrt((float)outpix.z));
    //uint4 outpix=sqrt((vert*vert)+(hor*hor));
    //float2 posf = (float2)(xycoords.x,xycoords.y);
    //uint4 pixel = read_imageui(in, sampf, posf);
    write_imageui(out, xycoords, outpix);
//    }
//  } 

}
