/*
 * GStreamer
 * Copyright (C) 2005 Thomas Vander Stichele <thomas@apestaart.org>
 * Copyright (C) 2005 Ronald S. Bultje <rbultje@ronald.bitfreak.net>
 * Copyright (C) 2012 Hannes <<user@hostname.org>>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 * Alternatively, the contents of this file may be used under the
 * GNU Lesser General Public License Version 2.1 (the "LGPL"), in
 * which case the following provisions apply instead of the ones
 * mentioned above:
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __GST_ROSPARAM_H__
#define __GST_ROSPARAM_H__

#include <gst/gst.h>

G_BEGIN_DECLS

/* #defines don't like whitespacey bits */
#define GST_TYPE_ROSPARAM \
  (gst_rosparam_get_type())
#define GST_ROSPARAM(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj),GST_TYPE_ROSPARAM,Gstrosparam))
#define GST_ROSPARAM_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass),GST_TYPE_ROSPARAM,GstrosparamClass))
#define GST_IS_ROSPARAM(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj),GST_TYPE_ROSPARAM))
#define GST_IS_ROSPARAM_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE((klass),GST_TYPE_ROSPARAM))

typedef struct _Gstrosparam      Gstrosparam;
typedef struct _GstrosparamClass GstrosparamClass;

/*enum lutype{
INT,
INT_RO,
FLOAT,
FLOAT_RO,
TEXT,
TEXT_RO,
BOOLEAN,
BOOLEAN_RO,
MENU
};*/

struct _Gstrosparam
{
  GstElement element;

  GstPad *sinkpad, *srcpad;

  gboolean silent;


  GList *propertylist;//list of properties we watch and export
  gchar* exportdsc;//export description as a CSV
  gchar* uidesc;
  gboolean firsttime;//is it the first-time to send sth 
  gboolean socketopen;
  gchar* remoteadress;
  gchar* conffiles;//a coma separated list of files that will be read to 
  int interval;

 GSocket *rsock;
 GSocketAddress * raddr;//adress
 gint rport;//recvport
 int rfd;//send file descriptor for fd
 GIOChannel* rchannel; //send channel

 GSocket *ssock;
 //GSocketAddress * saddr;//adress
 gint sport;//sendport, normally recvport +1
 gint width,height;
 GList *spinoffs;
 GList *controllers;
 guint source;
 int delay,extradelay;

 gint jport;
 gchar* jadress;
 GSocketAddress * jaddr;
 GInetAddress* jiaddr;
 gboolean sendj;
 gchar joinui[1024]; 
 gchar * topic;
 ros::NodeHandle* nh;
};

struct _GstrosparamClass 
{
  GstElementClass parent_class;
};

GType gst_rosparam_get_type (void);

G_END_DECLS

#endif /* __GST_ROSPARAM_H__ */
