/*
 * GStreamer
 * Copyright (C) 2005 Thomas Vander Stichele <thomas@apestaart.org>
 * Copyright (C) 2005 Ronald S. Bultje <rbultje@ronald.bitfreak.net>
 * Copyright (C) 2008 bistry <<user@hostname.org>>
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 * Alternatively, the contents of this file may be used under the
 * GNU Lesser General Public License Version 2.1 (the "LGPL"), in
 * which case the following provisions apply instead of the ones
 * mentioned above:
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/**
 * SECTION:element-rossiftfolder
 *
 * FIXME:Describe rossiftfolder here.
 *
 * <refsect2>
 * <title>Example launch line</title>
 * |[
 * gst-launch -v -m fakesrc ! rossiftfolder ! fakesink silent=TRUE
 * ]|
 * </refsect2>
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif



//#include "sift.h"
//#include "imgfeatures.h"
//#include "kdtree.h"
//#include "utils.h"
//#include "xform.h"
#include "math.h"

#include <sys/time.h>



#include <gst/gst.h>



//stuff for inotifysrc


#include <sys/types.h>
#include  <signal.h>
#include <sys/time.h>
#include <unistd.h>

//#include <linux/inotify.h>
#include <pthread.h>

#include <ros/ros.h>
#include <visualization_msgs/Marker.h>



#include <geometry_msgs/PoseStamped.h>
#include <sensor_msgs/CameraInfo.h>
#include "tf/tf.h"
#include "tf/tfMessage.h"
#include "tf/transform_broadcaster.h"

#include "cvsift.h"
#include "gstrossiftfolder.h"
#include "roscommon.h"
GST_DEBUG_CATEGORY_STATIC (gst_rosrossiftfolder_debug);
#define GST_CAT_DEFAULT gst_rosrossiftfolder_debug


/* Filter signals and args */
enum
{
  /* FILL ME */
  LAST_SIGNAL
};

enum
{
  PROP_0,
  PROP_SILENT,
  PROP_MAXSIM,
  PROP_MAXSIM2,
  PROP_GOODDIST,
  PROP_THRESHOLD,
  PROP_REMATCHDOUBLE,
  PROP_SHOWINLIERS,
  PROP_DIRECTORY,
  PROP_NTOTAL,
  PROP_THISN,
  PROP_THRESH,
  PROP_HFOV,
  PROP_UNDDIRECTORY,
  PROP_FRAMEID,
  PROP_CAMINFOTOPIC
};








/*
char* deserialize_int64 (gint64* result,const char * s)//gives end of char
{
  if (!s)return NULL;
  while (!isdigit(*s)&&(*s!=0)&&(*s!=45))s++;
  if (*s==0){
    //*result=NAN;
    return NULL;
  }
  char *end;
  *result = g_ascii_strtoll (s, &end, 0);
  return end;
}
*/
/* the capabilities of the inputs and outputs.
 *
 * describe the real formats here.
 */


static GstStaticPadTemplate sink_factory = GST_STATIC_PAD_TEMPLATE ("sink",
    GST_PAD_SINK,
    GST_PAD_ALWAYS,
    GST_STATIC_CAPS ("sift/raw,"
        "framerate = (fraction) [ 0, MAX ], "
        "width = (int) [ 1, MAX ], "
        "height = (int) [ 1, MAX ],"
        "overlap_x = (int) [ -1, MAX ], "
        "overlap_y = (int) [ -1, MAX ];"
	"sift/lowe;"
	"sift/oxf;"
	"sift/lowelight,"
        "width = (int) [ 1, MAX ], "
        "height = (int) [ 1, MAX ],"
        "overlap_x = (int) [ -1, MAX ], "
        "overlap_y = (int) [ -1, MAX ];")
    );

/*
static GstStaticPadTemplate src_factory = GST_STATIC_PAD_TEMPLATE ("src",
    GST_PAD_SRC,
    GST_PAD_ALWAYS,
    GST_STATIC_CAPS ("ANY")
    );
*/
static GstStaticPadTemplate src_factory = GST_STATIC_PAD_TEMPLATE ("src",
    GST_PAD_SRC,
    GST_PAD_ALWAYS,
    GST_STATIC_CAPS (
      "uber-coordinates")
    );
GST_BOILERPLATE (Gstrosrossiftfolder, gst_rosrossiftfolder, GstElement,
    GST_TYPE_ELEMENT);

void * watchthread (void* data);
static void gst_rosrossiftfolder_set_property (GObject * object, guint prop_id,
    const GValue * value, GParamSpec * pspec);
static void gst_rosrossiftfolder_get_property (GObject * object, guint prop_id,
    GValue * value, GParamSpec * pspec);
static gboolean gst_rosrossiftfolder_event (GstPad  *pad, GstEvent * event);
static gboolean gst_rosrossiftfolder_set_caps (GstPad * pad, GstCaps * caps);
static gboolean gst_rosrossiftfolder_load_gallery(Gstrosrossiftfolder * filter);
static GstFlowReturn gst_rosrossiftfolder_chain (GstPad * pad, GstBuffer * buf);
static GstStateChangeReturn
gst_rosrossiftfolder_change_state (GstElement *element, GstStateChange transition);
static GstCaps *
gst_rosrossiftfolder_get_src_caps (GstPad *pad);
static GstCaps *
gst_rosrossiftfolder_get_sink_caps (GstPad *pad);





/* GObject vmethod implementations */

static void
gst_rosrossiftfolder_base_init (gpointer gclass)
{
  GstElementClass *element_class = GST_ELEMENT_CLASS (gclass);

  gst_element_class_set_details_simple(element_class,
    "rossiftfolder",
    "Gst-Plugins-Robotix",
    "Match Sift-Features with folder",
    "Hannes Bistry <<hannesb@gmx.de>>");

  gst_element_class_add_pad_template (element_class,
      gst_static_pad_template_get (&src_factory));
  gst_element_class_add_pad_template (element_class,
      gst_static_pad_template_get (&sink_factory));
}

/* initialize the rossiftfolder's class */
static void
gst_rosrossiftfolder_class_init (GstrosrossiftfolderClass * klass)
{
  GObjectClass *gobject_class;
  GstElementClass *gstelement_class;

  gobject_class = (GObjectClass *) klass;
  gstelement_class = (GstElementClass *) klass;

  gobject_class->set_property = gst_rosrossiftfolder_set_property;
  gobject_class->get_property = gst_rosrossiftfolder_get_property;

  g_object_class_install_property (gobject_class, PROP_SILENT,
      g_param_spec_boolean ("silent", "Silent", "Produce verbose output ?",
          FALSE, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_MAXSIM,
      g_param_spec_double ("maxsim", "Maxsim", "The second best match needs to be (1/(maxsim)) further away(1==can even be equal, 0=never match)",
          0,1,0.49, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_MAXSIM2,
      g_param_spec_double ("maxsim2", "Maxsim2", "In case of a really good match (distance<gooddist), the second best match needs to be (1/(maxsim)) further away(1==can even be equal, 0=never match)",
          0,1,0.9, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_GOODDIST,
      g_param_spec_double ("gooddist", "Gooddist", "What is a good match, is square distance < than this value",
          0,1,0, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_THRESHOLD,
      g_param_spec_double ("threshold", "Threshold", "Threshold for Ransac",
          0,1,0.01, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_REMATCHDOUBLE,
      g_param_spec_boolean ("rematchdouble", "Rematchdouble", "Whether to kill double matches and rematch them in one direction.",
          TRUE, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_SHOWINLIERS,
      g_param_spec_boolean ("showinliers", "Showinliers", "Show only valid matches after Ransac.",
          FALSE, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_DIRECTORY,
      g_param_spec_string ("directory", "Directory", "Use this directory to build models.",
          NULL, G_PARAM_READWRITE));  
  g_object_class_install_property (gobject_class, PROP_NTOTAL,
      g_param_spec_int ("ntotal", "Ntotal", "Total Number of Instances on the same directory",
          -1,G_MAXINT,-1, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_THISN,
      g_param_spec_int ("thisn", "Thisn", "In ntotal is set, set this number between 0 and ntotal-1",
          -1,G_MAXINT,-1, G_PARAM_READWRITE));
  g_object_class_install_property (gobject_class, PROP_THRESH,
      g_param_spec_uint ("thresh", "Thresh", "Threshhold width/height where we scale down resolution",
          1,G_MAXUINT,G_MAXUINT, G_PARAM_READWRITE));
   g_object_class_install_property (gobject_class, PROP_HFOV,
      g_param_spec_double ("hfov", "Hfov", "Horizontal field of view (<0 is ignored)",
          -1,G_MAXDOUBLE,-1, G_PARAM_READWRITE)); 
  g_object_class_install_property (gobject_class, PROP_UNDDIRECTORY,
      g_param_spec_string ("unddirectory", "Unddirectory", "Undistort directory, if enabled, it overwrites hfov setting with calibration filoes and takes distortion_coeffs.",
          NULL, G_PARAM_READWRITE));   
   g_object_class_install_property (gobject_class, PROP_FRAMEID,
      g_param_spec_string ("frame_id", "Frame_is", "What frame_id will be attached to image message",
          "gstros_id", G_PARAM_READWRITE));  
   g_object_class_install_property (gobject_class, PROP_CAMINFOTOPIC,
      g_param_spec_string ("caminfotopic", "Caminfotopic", "Read out the camera info from a ros message",NULL, G_PARAM_READWRITE)); 
  gstelement_class->change_state = gst_rosrossiftfolder_change_state;
}

/* initialize the new element
 * instantiate pads and add them to element
 * set pad calback functions
 * initialize instance structure
 */
//static gboolean little_endian;

static void
gst_rosrossiftfolder_init (Gstrosrossiftfolder * filter,
    GstrosrossiftfolderClass * gclass)
{
  filter->sinkpad = gst_pad_new_from_static_template (&sink_factory, "sink");
  gst_pad_set_setcaps_function (filter->sinkpad,
                                GST_DEBUG_FUNCPTR(gst_rosrossiftfolder_set_caps));
  gst_pad_set_getcaps_function (filter->sinkpad,
                                GST_DEBUG_FUNCPTR(gst_rosrossiftfolder_get_sink_caps));
  gst_pad_set_chain_function (filter->sinkpad,
                              GST_DEBUG_FUNCPTR(gst_rosrossiftfolder_chain));
  //gst_pad_set_event_function (filter->sinkpad1,GST_DEBUG_FUNCPTR(gst_rosrossiftfolder_event));

  
  filter->srcpad = gst_pad_new_from_static_template (&src_factory, "src");
  gst_pad_set_getcaps_function (filter->srcpad,
                                GST_DEBUG_FUNCPTR(gst_rosrossiftfolder_get_src_caps));
  gst_pad_set_setcaps_function (filter->srcpad,
                                GST_DEBUG_FUNCPTR(gst_rosrossiftfolder_set_caps));
  gst_element_add_pad (GST_ELEMENT (filter), filter->sinkpad);
  gst_element_add_pad (GST_ELEMENT (filter), filter->srcpad);
  filter->silent = FALSE;
  filter->mutex=g_mutex_new();
  filter->maxsim=0.49;
  filter->maxsim2=0.9;
  filter->threshold=0.01;
  filter->showinliers=FALSE;
  filter->directory=NULL;
  filter->siftheap=0;
  filter->double_image=1;
  filter->th=0;

  filter->ntotal=-1;
  filter->thisn=-1;
  filter->thresh=G_MAXUINT;
  filter->rematchdouble=TRUE;
  
  
  
  filter->c_x=-1;
  filter->c_y=-1;
  filter->f_x=-1; 
  filter->f_y=-1;
  filter->k_1=0;
  filter->k_2=0;
  filter->k_3=0;
  filter->k_4=0;
  filter->k_5=0;
  
  filter->hfov=0;
  CvMat* distortion_coeffs=NULL;
  CvMat* intrinsic_matrix=NULL;
  filter->unddirectory=NULL;
  filter->frame_id=g_strdup_printf("gstros_id");
  filter->firsttime=TRUE;
  filter->topic=g_strdup_printf("siftobjects");
  filter->caminfotopic=NULL;
}

gboolean gst_element_is_null(GstElement* element){
  if (element==NULL)return FALSE;
  if (!GST_IS_ELEMENT(element))return FALSE;
  GstState current;
  gst_element_get_state(element,&current,NULL,1);
  if (current == GST_STATE_NULL) return TRUE;
  else return FALSE;
}

static gboolean gst_undistort_init_cvstuff(Gstrosrossiftfolder * filter){
  if (!filter->unddirectory)return FALSE;
  gchar * this_object_name = (gchar *) malloc(strlen(filter->unddirectory)+20);
  strcpy(this_object_name, filter->unddirectory);
  if (this_object_name[strlen(this_object_name)-2]!='/')strcat(this_object_name,"/");
  strcat(this_object_name,"Intrinsics.xml");
  //CvMat *intrinsic = (CvMat*)cvLoad(this_object_name,NULL,NULL,NULL);
  if (!filter->intrinsic_matrix)filter->intrinsic_matrix= (CvMat*)cvLoad(this_object_name,NULL,NULL,NULL);
  if (!filter->intrinsic_matrix){
    g_print("Could not load %s\n",this_object_name);
    return FALSE;
  }
  strcpy(this_object_name, filter->unddirectory);
  if (this_object_name[strlen(this_object_name)-2]!='/')strcat(this_object_name,"/");
  strcat(this_object_name,"Distortion.xml");  
  //CvMat *distortion = (CvMat*)cvLoad(this_object_name,NULL,NULL,NULL);
  if (!filter->distortion_coeffs)filter->distortion_coeffs = (CvMat*)cvLoad(this_object_name,NULL,NULL,NULL);
  if (!filter->distortion_coeffs){
    g_print("Could not load %s\n",this_object_name);    
    return FALSE;
  }
return TRUE;
}


static void
gst_rosrossiftfolder_set_property (GObject * object, guint prop_id,
    const GValue * value, GParamSpec * pspec)
{
  Gstrosrossiftfolder *filter = GST_ROSSIFTFOLDER (object);

  switch (prop_id) {
    case PROP_SILENT:
      filter->silent = g_value_get_boolean (value);
      break;
    case PROP_MAXSIM:
      filter->maxsim=g_value_get_double (value);
      break;
    case PROP_MAXSIM2:
      filter->maxsim2=g_value_get_double (value);
      break;
    case PROP_GOODDIST:
      filter->gooddist=g_value_get_double (value);
      break;
    case PROP_THRESHOLD:
      filter->threshold=g_value_get_double (value);
      break;
   case PROP_REMATCHDOUBLE:
      filter->rematchdouble = g_value_get_boolean (value);
      break;
   case PROP_SHOWINLIERS:
      filter->showinliers = g_value_get_boolean (value);
      break;
   case PROP_DIRECTORY:
      if(filter->directory)g_free (filter->directory);
      if (filter->th>0){
	pthread_cancel(filter->th);
	filter->th=0;
      }
      filter->directory = g_value_dup_string (value);
      /*if (!gst_rosrossiftfolder_load_gallery(filter)){
	if(filter->directory)g_free (filter->directory);
	filter->directory=NULL;
      }
      else{
	if (!gst_element_is_null(filter))pthread_create (&filter->th  , NULL, watchthread, filter);
	}*/
      break;
    case PROP_NTOTAL:
      filter->ntotal=g_value_get_int (value);
      break;
    case PROP_THISN:
      filter->thisn=g_value_get_int (value);
      break;
    case PROP_THRESH:
      filter->thresh=g_value_get_uint (value);
      break;
    case PROP_HFOV:
      filter->hfov=g_value_get_double (value);
      break;   
    case PROP_UNDDIRECTORY:
      if(filter->unddirectory)g_free (filter->unddirectory);   
      filter->unddirectory = g_value_dup_string (value);   
      gst_undistort_init_cvstuff(filter);
      break; 
    case PROP_FRAMEID:
      if (filter->frame_id)g_free (filter->frame_id);
      filter->frame_id = g_value_dup_string (value);
	//todo mutex,unadvertise,advertise,unlock
      break;  
    case PROP_CAMINFOTOPIC:
      if (filter->caminfotopic)g_free (filter->caminfotopic);
      filter->caminfotopic = g_value_dup_string (value);
	//todo mutex,unadvertise,advertise,unlock
      break; 
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
  }
}

static void
gst_rosrossiftfolder_get_property (GObject * object, guint prop_id,
    GValue * value, GParamSpec * pspec)
{
  Gstrosrossiftfolder *filter = GST_ROSSIFTFOLDER (object);

  switch (prop_id) {
    case PROP_SILENT:
      g_value_set_boolean (value, filter->silent);
      break;
    case PROP_MAXSIM:
      g_value_set_double(value, filter->maxsim);
      break;
    case PROP_MAXSIM2:
      g_value_set_double(value, filter->maxsim2);
      break;
    case PROP_GOODDIST:
      g_value_set_double(value, filter->gooddist);
      break;
    case PROP_THRESHOLD:
      g_value_set_double(value, filter->threshold);
      break;
    case PROP_REMATCHDOUBLE:
      g_value_set_boolean (value, filter->rematchdouble);
      break;
    case PROP_SHOWINLIERS:
      g_value_set_boolean (value, filter->showinliers);
      break;
    case PROP_DIRECTORY:     
      g_value_set_string (value, filter->directory);
      break;
    case PROP_NTOTAL:
      g_value_set_int (value,filter->ntotal);
      break;
    case PROP_THISN:
      g_value_set_int (value,filter->thisn);
      break;
    case PROP_THRESH:
      g_value_set_uint (value,filter->thresh);
      break;
    case PROP_HFOV:
      g_value_set_double (value,filter->hfov);
      break; 
    case PROP_UNDDIRECTORY:     
      g_value_set_string (value, filter->unddirectory);
    break;    
    case PROP_FRAMEID:
      g_value_set_string (value, filter->frame_id);     
    break; 
    case PROP_CAMINFOTOPIC:
      g_value_set_string (value, filter->caminfotopic);     
   break;
    default:
      G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
      break;
  }
}
//


/* GstElement vmethod implementations */

/* this function handles the link with other elements */
static gboolean
gst_rosrossiftfolder_set_caps (GstPad * pad, GstCaps * caps)
{
  gchar* capschar=gst_caps_to_string (caps);
  g_print("Sifttools set caps with %s!!\n",capschar);
  g_free(capschar);
  Gstrosrossiftfolder *filter;
  GstPad *otherpad;

  filter = GST_ROSSIFTFOLDER (gst_pad_get_parent (pad));
  otherpad = (pad == filter->srcpad) ? filter->sinkpad : filter->srcpad;
  gst_object_unref (filter);
  gboolean ret=TRUE;

  if (pad == filter->sinkpad){
     GstStructure *structure = gst_caps_get_structure (caps, 0);
     const gchar *mime;
     mime = gst_structure_get_name (structure);
     if (strcmp (mime, "sift/raw") == 0){
	gst_structure_get_int(structure,"width",&(filter->width1));
	gst_structure_get_int(structure,"height",&(filter->height1));
	filter->mode=0;
     }
     else if (strcmp (mime, "sift/lowe") == 0) filter->mode=1;
     else if (strcmp (mime, "sift/oxf") == 0) filter->mode=2;
     else if (strcmp (mime, "sift/lowelight") == 0){
	gst_structure_get_int(structure,"width",&(filter->width1));
	gst_structure_get_int(structure,"height",&(filter->height1));	
	filter->mode=3;
     }
     else ret=FALSE;
     gst_structure_get_double(structure,"c_x",&(filter->c_x));    
     gst_structure_get_double(structure,"c_y",&(filter->c_y));     
     gst_structure_get_double(structure,"f_x",&(filter->f_x));  
     gst_structure_get_double(structure,"f_x",&(filter->f_y));  
     gst_structure_get_double(structure,"k_1",&(filter->k_1));     
     gst_structure_get_double(structure,"k_2",&(filter->k_2));     
     gst_structure_get_double(structure,"k_3",&(filter->k_3)); 
     gst_structure_get_double(structure,"k_4",&(filter->k_4));     
     gst_structure_get_double(structure,"k_5",&(filter->k_5));     
	   
  }
  else ret=TRUE;
  //return gst_pad_set_caps (otherpad, caps);
  return ret;
}



static GstCaps *
gst_rosrossiftfolder_get_sink_caps (GstPad *pad){
  g_print("Start get sink caps!!\n");
  Gstrosrossiftfolder *filter;
  filter = GST_ROSSIFTFOLDER (GST_OBJECT_PARENT (pad));
  return gst_caps_copy(gst_pad_get_pad_template_caps(pad));
  
}

static GstCaps *
gst_rosrossiftfolder_get_src_caps (GstPad *pad){
  g_print("Start get src caps!!\n");
  Gstrosrossiftfolder *filter;

  filter = GST_ROSSIFTFOLDER (GST_OBJECT_PARENT (pad));



  GstCaps* outcaps;
  outcaps=gst_caps_new_simple ("uber-coordinates",
		NULL);
  //outcaps=gst_caps_copy(gst_pad_get_pad_template_caps(pad));
  //g_print("Returning %s!!\n",gst_caps_to_string(outcaps));
  return outcaps;
}

gboolean addfile(Gstrosrossiftfolder *filter, const gchar* object_name){//needs to be called with mutex
   gchar * this_object_name = (gchar *) malloc(strlen(filter->directory)+strlen(object_name) + 2);
   strcpy(this_object_name, filter->directory);
   if (this_object_name[strlen(this_object_name)-2]!='/')strcat(this_object_name,"/");
   strcat(this_object_name, object_name);
   g_print("Gstrosrossiftfolder reading %s\n",this_object_name);
   if (g_file_test(this_object_name,G_FILE_TEST_IS_REGULAR)){//seems to be broken
	  //get CVimage current
     IplImage* process = 0;
     process=cvLoadImage(this_object_name,0);//load as grayscale
     if (process){
       g_print("Gstrosrossiftfolder survived reading %s and threshold is %u\n",this_object_name,filter->thresh);
       if ((process->width>filter->thresh)||(process->height>filter->thresh)){
	 g_print("Resizing %s\n",this_object_name);
	 double factor;
	 if (process->width>process->height)factor=process->width/filter->thresh;
	 else factor=process->height/filter->thresh;
	  IplImage *destination = cvCreateImage
( cvSize((int)((double)(process->width)/factor) , (int)((double)(process->height)/factor )),
                                     8, 1 );
	 cvResize(process, destination,CV_INTER_LINEAR);
	 cvReleaseImage(&process);
	 process=destination;
	}
	    //
       struct siftset* newset;
       struct feature* newfeat=0;
       int num_features;
       newset=make_siftset(process,SIFT_INTVLS,filter->double_image);
       num_features=_sift_features(process,&newfeat ,newset, SIFT_INTVLS, SIFT_SIGMA, SIFT_CONTR_THR,
 			 SIFT_CURV_THR, filter->double_image, SIFT_DESCR_WIDTH,
			 SIFT_DESCR_HIST_BINS );
       if (!num_features){
	 g_print("Gstrosrossiftfolder adding %s failed, no features!\n",this_object_name);
	 killsiftset(newset);
         cvReleaseImage(&process);
         free(this_object_name);
         return FALSE;
	}
       struct kd_node* node;
       node = kdtree_build( newfeat, num_features );
       //add facts to siftheap
       struct siftheap* current=(struct siftheap*)malloc(sizeof(struct siftheap));
       current->numfeat=num_features;
       current->feat=newfeat;
       current->node=node;
       current->width=process->width;
       current->height=process->height;
       current->sent=0;
       current->advertised=0;
       strncpy(current->name,object_name,29);
       //if (strlen(object_name)<30)strcpy(current->name,object_name);
       //else memcpy(current->name,object_name,30);
       filter->siftheap=g_list_append(filter->siftheap,current);
       //tidy up
       killsiftset(newset);
       cvReleaseImage(&process);
       free(this_object_name);
       return TRUE;
      }
      else{ 
	g_print("Gstrosrossiftfolder reading %s failed, OpenCV could not generate image\n",this_object_name);
	free(this_object_name);
      }
   }
   else g_print("Gstrosrossiftfolder skipping %s, no regular file\n",this_object_name);
return FALSE;
}


void * watchthread (void* data)
{
  g_print("Start Watchthread!!\n");
  //sleep(10);
  Gstrosrossiftfolder *filter;  
  filter = GST_ROSSIFTFOLDER (data);
  char filename[512];
  filter->fd = inotify_init();
  if (filter->fd<0){
    printf("Siftfolder Watchthread: inotify init failed with error # %d, Errno %d\n", filter->fd, errno);
    return NULL;
  }
  filter->wd = inotify_add_watch( filter->fd,filter->directory , IN_CLOSE_WRITE | IN_MOVED_TO);
  //filter->wd = inotify_add_watch( filter->fd,filter->directory , IN_MOVED_TO);
  //filter->wd = inotify_add_watch( filter->fd,filter->directory , IN_CLOSE_WRITE);
  int length=0,i=0;
  while(42){
     if (i==0)length=read( filter->fd, filter->buffer, EVENT_BUF_LEN );
     if (i<0) printf("Siftfolder: inotify read returned Error %d\n", length);
     if (i<length){
       gboolean filename_valid=TRUE;
       int cntdots=0,j=0;	 
       struct inotify_event *pevent    = (struct inotify_event *) &filter->buffer[i];
       g_print("Siftfolder Watchthread: Event NR. %d, Filename: %s\n",i,pevent->name); 
       i += sizeof(struct inotify_event) + pevent->len;
      //strncpy(filename,filter->directory , 512);
      //if (filter->directory[strlen(filter->directory)-1]!='/') strncat(filename,"/",512);
       strncat(filename,pevent->name,512);
       g_print("Siftfolder Watchthread: Complete Name: %s\n",filename);
       for (j=0;j<strlen(filename);j++){
	  if (filename[j]=='.')cntdots++;
	  if ((filename[j]=='/')||(filename[j]=='\\'))cntdots=0;	  
       }
       if (cntdots!=1) filename_valid=FALSE;
       if (filename_valid){
         g_mutex_lock(filter->mutex);
         if((strstr(filename,".jpg"))||(strstr(filename,".png"))||(strstr(filename,".png"))||(strstr(filename,".JPG"))||(strstr(filename,".jpeg")))addfile(filter, filename);
         g_mutex_unlock(filter->mutex);
       }
       memset(filename,0,512);
       }
       if (i==length)i=0;
  }
  return NULL;
}


//function to load a gallery
static gboolean gst_rosrossiftfolder_load_gallery(Gstrosrossiftfolder * filter)
{
  g_mutex_lock(filter->mutex);
  //unref old siftheap
  filter->siftheap=NULL;//:)
  //iterate through gallery, pack all SIFT-vectors in a list
  //save identities while we go
  
  if( !g_file_test(filter->directory, G_FILE_TEST_IS_DIR) )
    return FALSE;
  
  GDir * gallery_dir = g_dir_open (filter->directory,0, NULL);
  const gchar * object_name;
  for ( object_name = g_dir_read_name(gallery_dir);
	object_name != NULL;
	object_name = g_dir_read_name(gallery_dir) ) {
          addfile(filter, object_name);
        }
  g_dir_close(gallery_dir);
  g_mutex_unlock(filter->mutex);
  return TRUE;
}


/* chain function
 * this function does the actual processing
 */
static GstFlowReturn
gst_rosrossiftfolder_chain (GstPad * pad, GstBuffer * buf)
{
  g_print("Start matcher!!\n");
  Gstrosrossiftfolder *filter;
  filter = GST_ROSSIFTFOLDER (GST_OBJECT_PARENT (pad)); 
  buf=gst_buffer_make_writable(buf);
  if (filter->siftheap==NULL){
      if (!gst_rosrossiftfolder_load_gallery(filter)){
        g_print("Warning, Gstrosrossiftfolder can not work because no objects to match, set directory path!!\n");	
	if(filter->directory)g_free (filter->directory);
	filter->directory=NULL;
      }
      else{
	if (!gst_element_is_null((GstElement*)filter))pthread_create (&filter->th  , NULL, watchthread, filter);
	}
      //g_mutex_unlock(filter->mutex);
      //return GST_FLOW_ERROR;
  }
  


 
  //get mutex
  g_mutex_lock(filter->mutex);

  if (filter->firsttime){

      int schrott=0;
      ros::init(schrott, NULL, "rossink", ros::init_options::AnonymousName);
      filter->nh = new ros::NodeHandle();
      filter->rpub=NULL;
      filter->rpub= new  ros::Publisher();

      gchar* topicname=g_strdup_printf("%s",filter->topic);
      *filter->rpub = filter->nh->advertise<visualization_msgs::Marker>(topicname, 1);
      g_free(topicname);

      //filter->tfpub= new  ros::Publisher();


      //gchar* tftopicname=g_strdup_printf("%s/tf",filter->topic);
      //*filter->tfpub = filter->nh->advertise<geometry_msgs::TransformStamped>(tftopicname, 1);
      //*filter->tfpub = filter->nh->advertise<tf::TransformStamped>(tftopicname, 1);
      //*filter->tfpub = filter->nh->advertise<geometry_msgs::TransformStamped>(tftopicname, 1);
      //*filter->tfpub = filter->nh->advertise<geometry_msgs::TransformStamped>("/tf", 1);
      //*filter->tfpub = filter->nh->advertise<tf::tfMessage::StampedTransform>("/tf", 1);
      //*filter->tfpub = filter->nh->advertise<tf::tfMessage>("/tf", 1);
      //g_free(tftopicname);
      filter->br=new tf::TransformBroadcaster();


      filter->firsttime=FALSE;

    if ((!filter->intrinsic_matrix)&&(filter->caminfotopic)){
      sensor_msgs::CameraInfoConstPtr camerainfo=ros::topic::waitForMessage<sensor_msgs::CameraInfo>(filter->caminfotopic,ros::Duration(5,0));
      if(camerainfo){
        printf("Retrieving camera info succeeded\n");

        filter->intrinsic_matrix  = cvCreateMat(3,3,CV_32FC1);
        filter->distortion_coeffs = cvCreateMat(5,1,CV_32FC1);
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 0, 0)=camerainfo->K[0];
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 0, 1)=0;
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 0, 2)=camerainfo->K[2];
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 1, 0)=0;
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 1, 1)=camerainfo->K[4];
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 1, 2)=camerainfo->K[5];
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 2, 0)=0;
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 2, 1)=0;
        CV_MAT_ELEM( *(filter->intrinsic_matrix), float, 2, 2)=1;

        CV_MAT_ELEM( *(filter->distortion_coeffs), float, 0, 0)=camerainfo->D[0];
        CV_MAT_ELEM( *(filter->distortion_coeffs), float, 1, 0)=camerainfo->D[1];
        CV_MAT_ELEM( *(filter->distortion_coeffs), float, 2, 0)=camerainfo->D[2];
        CV_MAT_ELEM( *(filter->distortion_coeffs), float, 3, 0)=camerainfo->D[3];
        CV_MAT_ELEM( *(filter->distortion_coeffs), float, 4, 0)=camerainfo->D[4];

        filter->frame_id=strdup(camerainfo->header.frame_id.c_str());

      }
      else printf("Retrieving camera info failed\n");
    }


  }
  

  //exchange buffer(unref old)
  switch(filter->mode){
    case 0:
      if (filter->s1)gst_buffer_unref(filter->s1);
      filter->s1=buf;
      filter->feat1=(struct feature*)buf->data;
      filter->n1=(buf->size)/(sizeof(struct feature));
      break;
    case 1:
      if (filter->s1)gst_buffer_unref(filter->s1);
      filter->s1=gst_buf_from_lowe((char*)buf->data);
      filter->s1->timestamp=buf->timestamp;
      filter->s1->duration=buf->duration;
      filter->s1->offset=buf->offset;
      filter->s1->offset_end=buf->offset_end;
      filter->feat1=(struct feature*)filter->s1->data;  
      filter->n1=(filter->s1->size)/(sizeof(struct feature));     
      gst_buffer_unref(buf);  
      break;
    case 2:
      if (filter->s1)gst_buffer_unref(filter->s1);
      filter->s1=gst_buf_from_oxfd((char*)buf->data);
      filter->s1->timestamp=buf->timestamp;
      filter->s1->duration=buf->duration;
      filter->s1->offset=buf->offset;
      filter->s1->offset_end=buf->offset_end;
      filter->feat1=(struct feature*)filter->s1->data;  
      filter->n1=(filter->s1->size)/(sizeof(struct feature));   
      gst_buffer_unref(buf);   
      break;
    case 3:
      if (filter->s1)gst_buffer_unref(filter->s1);
      filter->s1=gst_buf_from_lowelight(buf);
      filter->s1->timestamp=buf->timestamp;
      filter->s1->duration=buf->duration;
      filter->s1->offset=buf->offset;
      filter->s1->offset_end=buf->offset_end;
      filter->feat1=(struct feature*)filter->s1->data;  
      filter->n1=(filter->s1->size)/(sizeof(struct feature));    
      gst_buffer_unref(buf);   
      break;
    default:
      g_print("Serious Error!!\n");
      return GST_FLOW_ERROR; 
    }

    //g_print("Start Eval!!\n");

    
    
    GstFlowReturn ret;
    struct feature* feat;
    gint i,m=0,k;
    double d0, d1;
    struct feature** nbrs=NULL;
    CvMat* H=NULL;
    struct feature invalid;
    GList *temp;
    struct siftheap* current=NULL;
    struct kd_node* kd_root;
    if (filter->rematchdouble)filter->kdback = kdtree_build( filter->feat1, filter->n1 );
    for(temp=filter->siftheap;(temp);temp=g_list_next(temp))if ((filter->ntotal==-1)||(g_list_position (filter->siftheap,temp)%filter->ntotal==filter->thisn)){
      current=((struct siftheap*)(temp->data));
      kd_root=current->node;
      //delete backwards matches:
      for( i = 0; i < current->numfeat; i++ ){
	//current->feat->bck_match=NULL;
	//current->feat->fwd_match=NULL;
	current->feat[i].bck_match=NULL;
	current->feat[i].fwd_match=NULL;	
      }
      //g_print("allocated %d for a maximum number of %d features!!\n",filter->n1*sizeof(struct coordinates),filter->n1);
      for( i = 0; i < filter->n1; i++ ){
		  /*g_print("Checking 1  %d, because %p points to %p.\n",
		  i,
		  &filter->feat1[i],
		  filter->feat1[i].fwd_match
		 );*/     
                 filter->feat1[i].fwd_match=NULL;
      }
      for( i = 0; i < filter->n1; i++ )
        {
        //g_print("In for!!\n");
        //feat = filter->feat1 + i;
        feat = &filter->feat1[i];
        k = kdtree_bbf_knn( kd_root, feat, 2, &nbrs, 200 );//todo 200 to parameter
        if( k == 2 )
	  {
	  
	  d0 = descr_dist_sq( feat, nbrs[0] );
	  d1 = descr_dist_sq( feat, nbrs[1] );
	  if(( d0 < d1 * filter->maxsim )||((d0<filter->gooddist)&&(d0 < d1 * filter->maxsim2)))//0.49 to parameter
	    {
	      m++;
	      g_assert(filter->feat1[i].fwd_match == 0);
	      filter->feat1[i].fwd_match = nbrs[0];
             if (nbrs[0]->bck_match==NULL)
		nbrs[0]->bck_match = &filter->feat1[i];
	      else
		nbrs[0]->bck_match=&invalid;	      
// 	      g_print("feature %d x=%d y=%d corresponds to %p with x=%d y=%d and therefore the fwdmatch pointer is set to %p and backpointer is set to %p  / but should be %p!!\n",
// 		      i,
// 		      (int)filter->feat1[i].x,
// 		      (int)filter->feat1[i].y,
// 		      nbrs[0],
// 		      (int)nbrs[0]->x,
// 		      (int)nbrs[0]->y,
// 		      filter->feat1[i].fwd_match,
// 		      nbrs[0]->bck_match,
// 		      &filter->feat1[i]
// 		     );
	      //g_print("1 address of fwd_match %p\n", filter->feat1[16].fwd_match);
	    }
	}
      free( nbrs );
    }
    g_print("Found %d matches for object name %s!\n",m,current->name);
    m=0; 
    
    //g_print("2 address of fwd_match %p\n", filter->feat1[16].fwd_match);
    
    //if (filter->rematchdouble){//now the masterpiece, first the normal ones
//     for( i = 0; i < filter->n1; i++ )g_print("Checking 2 %d, because %p points to %p.\n",
// 		  i,
// 		  &filter->feat1[i],
// 		  filter->feat1[i].fwd_match
// 		 );
    if (filter->rematchdouble){
      //delete
      for( i = 0; i < filter->n1; i++ ){
        if ((filter->feat1[i].fwd_match != NULL) && (filter->feat1[i].fwd_match->bck_match!=&filter->feat1[i])){
// 	  g_print("deleting double %d, because %p points to %p and that points back to %p\n",
// 		  i,
// 		  &filter->feat1[i],
// 		  filter->feat1[i].fwd_match,
// 		  filter->feat1[i].fwd_match->bck_match
// 		 );
	  filter->feat1[i].fwd_match=NULL;
	  }
      }
    //rematch
      struct kd_node* kdback=filter->kdback;
      //kdback = kdtree_build( filter->feat1, filter->n1 );
      for( i = 0; i < current->numfeat; i++ ){
        if (current->feat[i].bck_match==&invalid){
          k = kdtree_bbf_knn( kdback,&current->feat[i], 2, &nbrs, 200 );
	  if (k==2){
	    current->feat[i].bck_match=nbrs[0];
	    nbrs[0]->fwd_match=&current->feat[i];
	  } 
        free( nbrs );	
        }
      }    
    //kdtree_release( kdback );
    }
    //Ransac transformation matrix generation
    int n_in;
    struct feature** inliers=NULL;
    H = ransac_xform( filter->feat1, filter->n1, FEATURE_FWD_MATCH, lsq_homog, 4, filter->threshold,
		      homog_xfer_err, 3.0, &inliers, &n_in );

    
    if (H){
        
        
        GstBuffer *outbuf;
        outbuf=gst_buffer_new_and_alloc(sizeof(struct uber_coordinates));
	struct uber_coordinates* bufdata=(struct uber_coordinates*)outbuf->data;
        outbuf->timestamp=filter->s1->timestamp;
	outbuf->duration=filter->s1->duration;
	outbuf->offset=filter->s1->offset;
	outbuf->offset_end=filter->s1->offset_end;
        gint x,y;
        gdouble bufscale;
	
	gint64 bfromname=-1;
         deserialize_int64 (&bfromname,current->name);
	if (bfromname>-1){//now we calculate the transformation
           gdouble elementsize=bfromname/1000.0;
	   g_print("We have %d inliers and now try to calculate the transformation for an Object with size of %f",n_in,elementsize);
	   CvMat* image_points      = cvCreateMat(n_in,2,CV_32FC1);
           CvMat* object_points     = cvCreateMat(n_in,3,CV_32FC1);   
           int i;
           for( i=0; i<n_in; ++i ) {
             CV_MAT_ELEM(*image_points, float,i,0) = inliers[i]->x;
             CV_MAT_ELEM(*image_points, float,i,1) = inliers[i]->y;
             CV_MAT_ELEM(*object_points,float,i,0) = (inliers[i]->fwd_match->x-(current->width/2.0))*(elementsize/current->width);
             CV_MAT_ELEM(*object_points,float,i,1) = ((inliers[i]->fwd_match->y-(current->height/2.0))*(elementsize/current->width));
             CV_MAT_ELEM(*object_points,float,i,2) = 0.0f;
           }    
           CvMat* rvec=cvCreateMat(3,1,CV_32FC1);
           CV_MAT_ELEM(*rvec, float,0,0) = 0;
           CV_MAT_ELEM(*rvec, float,1,0) = 0;
           CV_MAT_ELEM(*rvec, float,2,0) = 0;
           CvMat* tvec=cvCreateMat(3,1,CV_32FC1);   
           CV_MAT_ELEM(*tvec, float,0,0) = 0;
           CV_MAT_ELEM(*tvec, float,1,0) = 0;
           CV_MAT_ELEM(*tvec, float,2,0) = 0;
	   CvMat* intrinsic_matrix  = cvCreateMat(3,3,CV_32FC1);
	   double hfov=(3.14/180.0)*75;
	   if (filter->hfov>0) hfov=(3.14/180.0)*filter->hfov;
	   double f_x=((double)filter->width1)/(2.0*tan(hfov/2.0));
	   f_x=537;
	   CV_MAT_ELEM(*intrinsic_matrix, float,0,0) = f_x;
	   CV_MAT_ELEM(*intrinsic_matrix, float,1,1) = f_x;//same same
	   CV_MAT_ELEM(*intrinsic_matrix, float,2,2) = 1;
	   CV_MAT_ELEM(*intrinsic_matrix, float,0,2) = filter->width1/2.0-10;//c_x
	   CV_MAT_ELEM(*intrinsic_matrix, float,1,2) = filter->height1/2.0-10;//c_x
	   CV_MAT_ELEM(*intrinsic_matrix, float,0,1) =0;
	   CV_MAT_ELEM(*intrinsic_matrix, float,2,0) =0;
	   CV_MAT_ELEM(*intrinsic_matrix, float,2,1) =0;	  
	   CV_MAT_ELEM(*intrinsic_matrix, float,1,0) =0;		   
	   
	   
           if (filter->intrinsic_matrix && filter->distortion_coeffs)cvFindExtrinsicCameraParams2(object_points, image_points, filter->intrinsic_matrix, filter->distortion_coeffs, rvec, tvec,FALSE);
	   else cvFindExtrinsicCameraParams2(object_points, image_points, intrinsic_matrix, NULL, rvec, tvec,FALSE);
	   bufdata->rx=CV_MAT_ELEM(*tvec, float,0,0);
	   bufdata->ry=CV_MAT_ELEM(*tvec, float,1,0);
	   bufdata->rz=CV_MAT_ELEM(*tvec, float,2,0);
	   bufdata->rx=CV_MAT_ELEM(*rvec, float,0,0);
	   bufdata->ry=CV_MAT_ELEM(*rvec, float,1,0);
	   bufdata->rz=CV_MAT_ELEM(*rvec, float,2,0);	   
           if (filter->intrinsic_matrix && filter->distortion_coeffs)g_print ("Translation %.1f , %.1f , %.1f , Rotation %.1f , %.1f , %.1f with fx %f\n",100*CV_MAT_ELEM(*tvec, float,0,0),100*CV_MAT_ELEM(*tvec, float,1,0),100*CV_MAT_ELEM(*tvec, float,2,0),(180.0/3.14)*CV_MAT_ELEM(*rvec, float,0,0),(180.0/3.14)*CV_MAT_ELEM(*rvec, float,1,0),(180.0/3.14)*CV_MAT_ELEM(*rvec, float,2,0),CV_MAT_ELEM(*filter->intrinsic_matrix, float, 1, 1 ));
	   else g_print ("Translation %.1f , %.1f , %.1f , Rotation %.1f , %.1f , %.1f with fx %f fy %f \n",100*CV_MAT_ELEM(*tvec, float,0,0),100*CV_MAT_ELEM(*tvec, float,1,0),100*CV_MAT_ELEM(*tvec, float,2,0),(180.0/3.14)*CV_MAT_ELEM(*rvec, float,0,0),(180.0/3.14)*CV_MAT_ELEM(*rvec, float,1,0),(180.0/3.14)*CV_MAT_ELEM(*rvec, float,2,0),f_x,CV_MAT_ELEM( *intrinsic_matrix, float, 1, 1 ));
	   
	   CvMat* rota=cvCreateMat(3,3,CV_32FC1);
           cvRodrigues2(rvec, rota, NULL );
           double w,x,y,z;
           genquat( &w,&x,&y ,&z,rota);


	//y-front style
          tf::Quaternion quat=tf::Quaternion(x,y,z,w);

	   
	   //now the ROS Stuff - Transformation
		if (!current->advertised){
		  gchar* cutname=g_malloc0(1024);
		  //int tocopy=(strchr(current->name,'.'))-current->name;
		  int tocopy=0;
		  while (isalpha(current->name[tocopy]))tocopy++;
		  if (tocopy>1024){
			g_print("Warning filename is %d long, will crash \n",tocopy);
			sleep(10);
		  }
		  memcpy(cutname,current->name,tocopy);
		  gchar* topicname=g_strdup_printf("%s/%s",filter->topic,cutname);
		  g_print("Advertising %s because object detected. \n",topicname);
		  current->rpub= new  ros::Publisher();
      		  *current->rpub = filter->nh->advertise<geometry_msgs::PoseStamped>(topicname, 1);
		  g_print("Survived advertising %s \n",topicname);
		  g_free(topicname);
		  g_free(cutname);
		  current->advertised=1;
		}


//für eine Kamera wo die Y-Achse aus der Linse kommt
		double posx=CV_MAT_ELEM(*tvec, float,0,0);
		double posy=CV_MAT_ELEM(*tvec, float,1,0);
		double posz=CV_MAT_ELEM(*tvec, float,2,0);


		//publish the TF
		//eometry_msgs::TransformStamped trst;
		tf::StampedTransform trst;

		trst.frame_id_.assign(filter->frame_id);
		trst.stamp_.sec=buf->timestamp/1000000000ULL;
		trst.stamp_.nsec=buf->timestamp%1000000000ULL;
		//just a auxilary functions to remove numbers from the frame
		  gchar* cutname=g_malloc0(1024);
		  int tocopy=0;
		  while (isalpha(current->name[tocopy]))tocopy++;
		  g_assert(tocopy<1024);
		  memcpy(cutname,current->name,tocopy);
		//! just a auxilary functions to remove numbers from the frame
		trst.child_frame_id_.assign(cutname);
		g_free(cutname);
		trst.setOrigin( tf::Vector3(posx,posy,posz) );
	        //trst.setRotation( tf::Quaternion(CV_MAT_ELEM(*rvec, float,0,0), -CV_MAT_ELEM(*rvec, float,1,0), CV_MAT_ELEM(*rvec, float,2,0)) );
		trst.setRotation(tf::Quaternion(x,y,z,w));

		filter->br->sendTransform(trst);
		//filter->tfpub->publish(trst);
	        if (!filter->silent) g_print ("Rossink start spinning after sending tf stamped.\n");
		ros::spinOnce();




	  //now the ROS visualization markers
	       visualization_msgs::Marker marker;
    // Set the frame ID and timestamp.  See the TF tutorials for information on these.
		marker.header.frame_id.assign(filter->frame_id);
		//marker.header.stamp = ros::Time::now();
		marker.header.stamp.sec=buf->timestamp/1000000000ULL;
		marker.header.stamp.nsec=buf->timestamp%1000000000ULL;
		// Set the namespace and id for this marker.  This serves to create a unique ID
		// Any marker sent with the same namespace and id will overwrite the old one
		marker.ns.assign(current->name);
		marker.id = 0;

		// Set the marker type.  Initially this is CUBE, and cycles between that and SPHERE, ARROW, and CYLINDER
		marker.type = visualization_msgs::Marker::CUBE;

		// Set the marker action.  Options are ADD and DELETE
		marker.action = visualization_msgs::Marker::ADD;

		// Set the scale of the marker -- 1x1x1 here means 1m on a side
		marker.scale.z = elementsize;
		marker.scale.y = (elementsize/current->width)*current->height;
		marker.scale.x = elementsize;//just guess
		if (strstr(current->name,"kellogs"))marker.scale.z = 0.047;//TOFIX:)
		if (strstr(current->name,"tropicana"))marker.scale.z = 0.071;//TOFIX:)
		if (strstr(current->name,"panodil"))marker.scale.z = 0.019;//TOFIX:)
		if (strstr(current->name,"activia"))marker.scale.z = 0.068;//TOFIX:)
		if (strstr(current->name,"extra"))marker.scale.z = 0.053;//TOFIX:)
		if (strstr(current->name,"pringles"))marker.scale.z = 0.080;//TOFIX:)
		if (strstr(current->name,"escafe"))marker.scale.z = 0.057;//TOFIX:)
				

		//NEW, calculate offset of center
		tf::Transform transco=tf::Transform(tf::Quaternion(x,y,z,w), tf::Vector3(posx,posy,posz));//camera object surface
  		tf::Transform transoc=tf::Transform(tf::Quaternion(0,0,0,1), tf::Vector3(0,0,(marker.scale.z/2)));//object surface object center
		tf::Transform transfinal=transco*transoc;//the resulting 




		// Set the pose of the marker.  This is a full 6DOF pose relative to the frame/time specified in the header
		marker.pose.position.x = transfinal.getOrigin().x();

		marker.pose.position.y = transfinal.getOrigin().y();
		marker.pose.position.z = transfinal.getOrigin().z();	
		marker.pose.orientation.x = transfinal.getRotation().x();
		marker.pose.orientation.y = transfinal.getRotation().y();
		marker.pose.orientation.z = transfinal.getRotation().z();
		marker.pose.orientation.w = transfinal.getRotation().w();


		// Set the color -- be sure to set alpha to something non-zero!
		marker.color.r = 0.0f;
		marker.color.g = 1.0f;
		marker.color.b = 0.0f;
		marker.color.a = 1.0;

		marker.lifetime = ros::Duration();

		// Publish the marker
		current->sent=1;
		filter->rpub->publish(marker);
	        if (!filter->silent) g_print ("Rossink start spinning.\n");
		ros::spinOnce();
		//Publish the TF Pose Stamped Message
		geometry_msgs::PoseStamped postst;
		postst.header.frame_id.assign(filter->frame_id);
		postst.header.stamp.sec=buf->timestamp/1000000000ULL;
		postst.header.stamp.nsec=buf->timestamp%1000000000ULL;
		postst.pose.position.y = posy;
		postst.pose.position.z = posz;
		postst.pose.position.x = posx;
		postst.pose.orientation.x = x;
		postst.pose.orientation.y = y;
		postst.pose.orientation.z = z;
		postst.pose.orientation.w = w;
			
		current->rpub->publish(postst);
	        if (!filter->silent) g_print ("Rossink start spinning after sending pose stamped.\n");
		ros::spinOnce();

	   //!the ROS Stuff
	   //cvReleaseMat(&invrotmat);	  
	   //cvReleaseMat(&rotmat);	   
	   //cvReleaseMat(&invrvec);
	   //cvReleaseMat(&inv_homo_matrix);
	   //cvReleaseMat(&homo_matrix);
	   cvReleaseMat(&image_points);
           cvReleaseMat(&object_points);
           cvReleaseMat(&rvec);
           cvReleaseMat(&tvec);
	  cvReleaseMat(&intrinsic_matrix);
	  
	  
	  
	}
	
	
	
        //g_print("The point is x=%d and y=%d \n",(int)(filter->width2/2.0),(int)(filter->height2*0.9));
//  	printf("matrix data %f %f %f\n",cvmGet(H,0,0),cvmGet(H,0,1),cvmGet(H,0,2));
// 	printf("matrix data %f %f %f\n",cvmGet(H,1,0),cvmGet(H,1,1),cvmGet(H,1,2));
// 	printf("matrix data %f %f %f\n",cvmGet(H,2,0),cvmGet(H,2,1),cvmGet(H,2,2));

        double src_matrix[9], dst_matrix[9];
        CvMat A = cvMat( 3, 3, CV_64F, src_matrix ),
        invA = cvMat( 3, 3, CV_64F, dst_matrix );
        cvConvertScale( H, &A ,1,0);
        cvInvert( &A, &invA, CV_SVD );
	
//  	printf("inverted matrix data %f %f %f\n",cvmGet(&invA,0,0),cvmGet(&invA,0,1),cvmGet(&invA,0,2));
// 	printf("inverted matrix data %f %f %f\n",cvmGet(&invA,1,0),cvmGet(&invA,1,1),cvmGet(&invA,1,2));
// 	printf("inverted matrix data %f %f %f\n",cvmGet(&invA,2,0),cvmGet(&invA,2,1),cvmGet(&invA,2,2));
// 
 	//printf("inverted normalized matrix data %f %f %f\n",cvmGet(&invA,0,0)/cvmGet(&invA,2,2),cvmGet(&invA,0,1)/cvmGet(&invA,2,2),cvmGet(&invA,0,2)/cvmGet(&invA,2,2));
 	//printf("inverted normalized matrix data %f %f %f\n",cvmGet(&invA,1,0)/cvmGet(&invA,2,2),cvmGet(&invA,1,1)/cvmGet(&invA,2,2),cvmGet(&invA,1,2)/cvmGet(&invA,2,2));
 	//printf("inverted normalized matrix data %f %f %f\n",cvmGet(&invA,2,0)/cvmGet(&invA,2,2),cvmGet(&invA,2,1)/cvmGet(&invA,2,2),cvmGet(&invA,2,2)/cvmGet(&invA,2,2));

	bufdata->a00=cvmGet(&invA,0,0)/cvmGet(&invA,2,2);
	bufdata->a01=cvmGet(&invA,0,1)/cvmGet(&invA,2,2);
	bufdata->a02=cvmGet(&invA,0,2)/cvmGet(&invA,2,2);
	bufdata->a10=cvmGet(&invA,1,0)/cvmGet(&invA,2,2);
	bufdata->a11=cvmGet(&invA,1,1)/cvmGet(&invA,2,2);
	bufdata->a12=cvmGet(&invA,1,2)/cvmGet(&invA,2,2);
	bufdata->a20=cvmGet(&invA,2,0)/cvmGet(&invA,2,2);
	bufdata->a21=cvmGet(&invA,2,1)/cvmGet(&invA,2,2);
	bufdata->a22=cvmGet(&invA,2,2)/cvmGet(&invA,2,2);

	bufdata->x1=cvmGet(&invA,0,2)/cvmGet(&invA,2,2);
	bufdata->y1=cvmGet(&invA,1,2)/cvmGet(&invA,2,2);		
        bufscale=(cvmGet(&invA,2,0)*((gdouble)current->width)+cvmGet(&invA,2,1)*((float)current->height)+cvmGet(&invA,2,2));
	bufdata->x2=(cvmGet(&invA,0,0)*((gdouble)current->width)+cvmGet(&invA,0,1)*((float)current->height)+cvmGet(&invA,0,2))/bufscale;
	bufdata->y2=(cvmGet(&invA,1,0)*((gdouble)current->width)+cvmGet(&invA,1,1)*((float)current->height)+cvmGet(&invA,1,2))/bufscale;	
	bufdata->angle=atan2((cvmGet(&invA,0,0)/cvmGet(&invA,2,2)),(cvmGet(&invA,0,0)/cvmGet(&invA,2,2)));
	if (bufdata->x1>bufdata->x2){
	   gdouble tempx=bufdata->x1;
	   bufdata->x1=bufdata->x2;
	   bufdata->x2=tempx;
  	}
	if (bufdata->y1>bufdata->y2){
	   gdouble tempy=bufdata->y1;
	   bufdata->y1=bufdata->y2;
	   bufdata->y2=tempy;
  	}
	//bufdata->scale=(cvmGet(&invA,0,0)/cvmGet(&invA,2,2))*(cvmGet(&invA,0,0)/cvmGet(&invA,2,2))+(cvmGet(&invA,0,0)/cvmGet(&invA,2,2))*(cvmGet(&invA,0,0)/cvmGet(&invA,2,2));

	
	bufdata->imagewidth=(int)filter->width1;//size of the image where we found this 
	bufdata->imageheight=(int)filter->height1;//
	bufdata->mwidth=(int)current->width;//size of the model that we used to find this this   
	bufdata->mheight=(int)current->height;//
	bufdata->timestamp=outbuf->timestamp;
	bufdata->scale=sqrt(((bufdata->y2-bufdata->y1)*(bufdata->y2-bufdata->y1))+((bufdata->x2-bufdata->x1)*(bufdata->x2-bufdata->x1)))/sqrt((bufdata->mwidth*bufdata->mwidth)+(bufdata->mheight*bufdata->mheight));
	strncpy(bufdata->name,current->name,29);	
	//g_print("Found transformation for object name %s, starting Point x=%f y=%f, going to x=%f y=%f  scale  is %f!\n",current->name,bufdata->x1,bufdata->y1,bufdata->x2,bufdata->y2,bufdata->scale);
        //now we send it
        GstCaps *tmpcaps=gst_caps_new_simple ("uber-coordinates",NULL);
        gst_buffer_set_caps(outbuf,tmpcaps);	
	gst_caps_unref(tmpcaps);
	ret=gst_pad_push (filter->srcpad, outbuf);
	if (ret!=GST_FLOW_OK){
	  g_mutex_unlock(filter->mutex);
	  return ret;
	  }
	cvReleaseMat( &H ); 
    }
    else{
        if (current->sent==1){
	  //send delete message
	  visualization_msgs::Marker marker;
    // Set the frame ID and timestamp.  See the TF tutorials for information on these.
	  marker.header.frame_id.assign(filter->frame_id);
    //marker.header.stamp = ros::Time::now();
          marker.header.stamp.sec=buf->timestamp/1000000000ULL;
	  marker.header.stamp.nsec=buf->timestamp%1000000000ULL;
		// Set the namespace and id for this marker.  This serves to create a unique ID
		// Any marker sent with the same namespace and id will overwrite the old one
	  marker.ns.assign(current->name);
	  marker.id = 0;

		// Set the marker type.  Initially this is CUBE, and cycles between that and SPHERE, ARROW, and CYLINDER
	  marker.type = visualization_msgs::Marker::CUBE;

		// Set the marker action.  Options are ADD and DELETE
	  marker.action = visualization_msgs::Marker::DELETE;
	  filter->rpub->publish(marker);
	  if (!filter->silent) g_print ("Rossink start spinning.\n");
	  ros::spinOnce();
	  current->sent=0;
	}
      
        //g_print("Sorry, could not find transformation!\n");
	GstBuffer *outbuf;
        outbuf=gst_buffer_new_and_alloc(sizeof(struct uber_coordinates));
	struct uber_coordinates* bufdata=(struct uber_coordinates*)outbuf->data;
        outbuf->timestamp=filter->s1->timestamp;
	outbuf->duration=filter->s1->duration;
	outbuf->offset=filter->s1->offset;
	outbuf->offset_end=filter->s1->offset_end;
        memset (bufdata,0,sizeof(struct uber_coordinates));
	strncpy(bufdata->name,current->name,29);
		bufdata->imagewidth=filter->width1;//size of the image where we found this 
	bufdata->imageheight=filter->height1;//
	bufdata->mwidth=current->width;//size of the model that we used to find this this   
	bufdata->mheight=current->height;//
	bufdata->timestamp=outbuf->timestamp;
        GstCaps *tmpcaps=gst_caps_new_simple ("uber-coordinates",NULL);
        gst_buffer_set_caps(outbuf,tmpcaps);	
	gst_caps_unref(tmpcaps);
        //now we send it
	ret=gst_pad_push (filter->srcpad, outbuf);
	if (ret!=GST_FLOW_OK){
	  g_mutex_unlock(filter->mutex);
	  return ret;
	  }
	}
       if (inliers)free(inliers);
    }//the for-loop that iterstes all known objects
    if (filter->rematchdouble)kdtree_release(filter->kdback );
  g_mutex_unlock(filter->mutex);
  return GST_FLOW_OK; 
}

static GstStateChangeReturn
gst_rosrossiftfolder_change_state (GstElement *element, GstStateChange transition){
  GstStateChangeReturn ret = GST_STATE_CHANGE_SUCCESS;
  Gstrosrossiftfolder *filter;
  filter = GST_ROSSIFTFOLDER (element);

  switch (transition) {
    case GST_STATE_CHANGE_NULL_TO_READY:
      //if (filter->directory)pthread_create (&filter->th  , NULL, watchthread, filter);
      break;
      
      
      
    case GST_STATE_CHANGE_READY_TO_PAUSED:      
      if (filter->siftheap==NULL){
	if (!gst_rosrossiftfolder_load_gallery(filter)){
	  g_print("Warning, Gstrosrossiftfolder can not work because no objects to match, set directory path!!\n");	
	  if(filter->directory)g_free (filter->directory);
	  filter->directory=NULL;
	}
	else{
	  if (!gst_element_is_null((GstElement*)filter))pthread_create (&filter->th  , NULL, watchthread, filter);
	  }
      }
    default:
      break;
  }

  ret = GST_ELEMENT_CLASS (parent_class)->change_state (element, transition);
  if (ret == GST_STATE_CHANGE_FAILURE)
    return ret;

  switch (transition) {
    case GST_STATE_CHANGE_READY_TO_NULL:
      //gst_my_filter_free_memory (filter);
      if (filter->s1) gst_buffer_unref(filter->s1);
      filter->s1=NULL;
      if (filter->th>0){
	pthread_cancel(filter->th);
	filter->th=0;
      }
      if (filter->rpub!=NULL)filter->rpub->shutdown();
      //ros::shutdown();
      filter->firsttime=TRUE;
      break;
    default:
      break;
  }
 return ret;
}





static gboolean
gst_rosrossiftfolder_event (GstPad  *pad, GstEvent * event)
{
  Gstrosrossiftfolder *filter;
  gboolean ret=TRUE;
  //GstPad *otherpad;

  filter = GST_ROSSIFTFOLDER (gst_pad_get_parent (pad));

  switch (GST_EVENT_TYPE (event)) {
    //case GST_EVENT_EOS:
      //if (pad == filter->sinkpad1) filter->stopped1=TRUE;
      //if (pad == filter->sinkpad2) filter->stopped2=TRUE;
      ///if ((filter->stopped1)&&(filter->stopped2)) ret = gst_pad_push_event (filter->srcpad, event);
      //g_print("Event EOS!\n");
      //break;
    default:
      ret = gst_pad_push_event (filter->srcpad, event);
      break;
  }
  
  gst_object_unref (filter);
  return ret;
}





/* entry point to initialize the plug-in
 * initialize the plug-in itself
 * register the element factories and other features
 */

//static gboolean
//rossiftfolder_init (GstPlugin * rossiftfolder)
//{
  /* debug category for fltering log messages
   *
   * exchange the string 'Template rossiftfolder' with your description
   */
//  GST_DEBUG_CATEGORY_INIT (gst_rosrossiftfolder_debug, "SiftFolder",
//      0, "Template Sifttools");
  //g_print("Registering Sifttools with pointer %p\n",rossiftfolder);
//  return gst_element_register (rossiftfolder, "rossiftfolder", GST_RANK_NONE,
//      GST_TYPE_ROSSIFTFOLDER);
//}

/* gstreamer looks for this structure to register rossiftfolders
 *
 * exchange the string 'Template rossiftfolder' with your rossiftfolder description
 */
/*
GST_PLUGIN_DEFINE (
    GST_VERSION_MAJOR,
    GST_VERSION_MINOR,
    "SiftFolder",
    "Matches SIFT-Vector to folder",
    rossiftfolder_init,
    VERSION,
    "LGPL",
    "GStreamer",
    "http://gstreamer.net/"
)*/
