#include "roscommon.h"
//#include <gst/base/gstbasesink.h>
//#include <gdk/gdk.h>
//#include <stdio.h>
//#include <stdlib.h>
//#include <string.h>
//#include <ctype.h>



void * commonspinner (GCond* cond, GMutex* mutex){
  static int spinned=0;
  if (spinned==0){
    spinned=1;
    ros::spin();
  }
  else ros::waitForShutdown();
  //Awake my thread
  if ((cond)&&(mutex)){
    g_mutex_lock (mutex);
    g_cond_signal (cond);
    g_mutex_unlock (mutex);
  }
  g_print("Returned from spinning\n");
    //gst_rossrc_stop ((GstBaseSrc *) insrc);
  return NULL;
}




gchar* gst_pad_get_pe_name(GstPad *pad){
  GstPad * peer=gst_pad_get_peer(pad);
  if (!peer)return NULL;
  GstElement* pe=gst_pad_get_parent_element (peer);
  gst_object_unref(peer);
  if (!pe)return NULL;
  gchar* result=gst_element_get_name(pe);
  gst_object_unref(pe);
  return result;
}
 

char* deserialize_uint64 (guint64* result,const char * s)//gives end of char
{
  if (!s)return NULL;
  while (!isdigit(*s)&&(*s!=0))s++;
  if (*s==0){
    //*result=NAN;
    return NULL;
  }
  char *end;
  *result = g_ascii_strtoull (s, &end, 0);
  return end;
}
char* deserialize_int64 (gint64* result,const char * s)//gives end of char
{
  if (!s)return NULL;
  while (!isdigit(*s)&&(*s!=0)&&(*s!=45))s++;
  if (*s==0){
    //*result=NAN;
    return NULL;
  }
  char *end;
  *result = g_ascii_strtoll (s, &end, 0);
  return end;
}

char* deserialize_double (gdouble* result,const char * s)//gives end of char
{
  if (!s)return NULL;
  while (!isdigit(*s)&&(*s!=0)&&(*s!=45))s++;
  if (*s==0){
    //*result=NAN;
    return NULL;
  }
  char *end;
  //*result = g_ascii_strtod (s, &end);
  *result = strtod (s, &end);
  return end;
}

char* deserialize_string (char* result,const char * s)//gives end of char
{
  if (!s)return NULL;
  printf("String to parse %s\n",s);
  while (!isalpha(*s)&&(*s!=0)) s++;//segfault ;)
  //printf("String after cutting semicolons %s\n",s);
  if (*s == 0)return NULL;
  char *end=strchr(s,';');
  char *end2=strchr(s,'[');
  char *end3=strchr(s,0);
  if (!end)end=end3;
  if (!end2)end2=end3; 
  if (end>end2)end=end2; 
  //printf("Copy %d",(end-s));
  if ((!end)||((end-s)>MAXSTRING))return NULL;
  //g_print ("Copy Startpointer %p , Endpointer %p, target %p %d bytes\n",s,end,result,(end-s)); 
  memcpy(result,s,(end-s));
  *(result+(end-s))=0;//letzter wird endcharackter
  return end;
}

char* deserialize_string2 (char* result,const char * s, char separator)//gives end of char
{
  if (!s)return NULL;
  printf("String to parse %s\n",s);
  while (!isalnum(*s)&&(*s!=0)) s++;//segfault ;)
  //printf("String after cutting semicolons %s\n",s);
  if (*s == 0)return NULL;
  char *end=strchr(s,separator);
  char *end3=strchr(s,0);
  if (!end)end=end3;
  //printf("Copy %d",(end-s));
  if ((!end)||((end-s)>MAXSTRING))return NULL;
  //g_print ("Copy Startpointer %p , Endpointer %p, target %p %d bytes\n",s,end,result,(end-s)); 
  memcpy(result,s,(end-s));
  *(result+(end-s))=0;//letzter wird endcharackter
  return end;
}

int swapint(int ui)
{
    int result;
    result = (ui >> 24) |
         ((ui<<8) & 0x00FF0000) |
         ((ui>>8) & 0x0000FF00) |
         (ui << 24);
    return result;
}

void genquat( double *w,double *x,double *y ,double *z, CvMat* rota ){
  float trace = CV_MAT_ELEM(*rota, float,0,0) + CV_MAT_ELEM(*rota, float,1,1) + CV_MAT_ELEM(*rota, float,2,2); // I removed + 1.0f; see discussion with Ethan
  if( trace > 0 ) {// I changed M_EPSILON to 0
    float s = 0.5f / sqrtf(trace+ 1.0f);
    *w = 0.25f / s;
    *x = ( CV_MAT_ELEM(*rota, float,2,1) - CV_MAT_ELEM(*rota, float,1,2) ) * s;
    *y = ( CV_MAT_ELEM(*rota, float,0,2) - CV_MAT_ELEM(*rota, float,2,0) ) * s;
    *z = ( CV_MAT_ELEM(*rota, float,1,0) - CV_MAT_ELEM(*rota, float,0,1) ) * s;
  } else {
    if ( (CV_MAT_ELEM(*rota, float,0,0) > CV_MAT_ELEM(*rota, float,1,1)) && (CV_MAT_ELEM(*rota, float,0,0) > CV_MAT_ELEM(*rota, float,2,2)) ) {
      float s = 2.0f * sqrtf( 1.0f + CV_MAT_ELEM(*rota, float,0,0) - CV_MAT_ELEM(*rota, float,1,1) - CV_MAT_ELEM(*rota, float,2,2));
      *w = (CV_MAT_ELEM(*rota, float,2,1) - CV_MAT_ELEM(*rota, float,1,2)  ) / s;
      *x = 0.25f * s;
      *y = (CV_MAT_ELEM(*rota, float,1,0) + CV_MAT_ELEM(*rota, float,0,1) ) / s;
      *z = (CV_MAT_ELEM(*rota, float,0,2) + CV_MAT_ELEM(*rota, float,2,0) ) / s;
    } else if (CV_MAT_ELEM(*rota, float,1,1)>CV_MAT_ELEM(*rota, float,2,2)) {
      float s = 2.0f * sqrtf( 1.0f + CV_MAT_ELEM(*rota, float,1,1) - CV_MAT_ELEM(*rota, float,0,0) - CV_MAT_ELEM(*rota, float,2,2));
      *w = (CV_MAT_ELEM(*rota, float,0,2) - CV_MAT_ELEM(*rota, float,2,0) ) / s;
      *x = (CV_MAT_ELEM(*rota, float,1,0) + CV_MAT_ELEM(*rota, float,0,1) ) / s;
      *y = 0.25f * s;
      *z = ( CV_MAT_ELEM(*rota, float,2,1) + CV_MAT_ELEM(*rota, float,1,2)) / s;
    } else {
      float s = 2.0f * sqrtf( 1.0f + CV_MAT_ELEM(*rota, float,2,2) - CV_MAT_ELEM(*rota, float,0,0) -  CV_MAT_ELEM(*rota, float,1,1));
      *w = (CV_MAT_ELEM(*rota, float,1,0) - CV_MAT_ELEM(*rota, float,0,1) ) / s;
      *x = (CV_MAT_ELEM(*rota, float,0,2) + CV_MAT_ELEM(*rota, float,2,0)) / s;
      *y = (CV_MAT_ELEM(*rota, float,2,1) + CV_MAT_ELEM(*rota, float,1,2) ) / s;
      *z = 0.25f * s;
    }
  }
}
