#ifndef __GST_ROSCOMMON__
#define __GST_ROSCOMMON__

#define MAXSTRING 10000

#include <ros/ros.h>
#include <gio/gio.h>

#include <gst/gst.h>
#include <cv.h>

static gboolean little_endian;

struct property{
 GstElement* elpointer;
 gchar* elname;//name of gstreamer element
 gchar* propertyname;//name of the property
 gchar* alias;//alias, for later use  - maybe
 GParamSpec* spec;//pointer to spec
 //enum lutype type;//
 gdouble currentnum,min,max;
 gint64 currentnumi,mini,maxi;
 gchar* charval;
 gboolean active;//active for gboolean
 gboolean pending;//whether currently a change occurs;
};


struct spinoff
{
 //GSocket *ssock;
 GSocketAddress * saddr;
 GSocketAddress * spxpaddr;
 char name[128];//network Name of device
 GInetAddress* iaddr;
 //char ipname[128];//network Name of device
 int state;//0 Stop 7=play sent, 8=play confirm received
 char ui[1024];//network Name of device
};

struct controller
{
 //GSocket *ssock;
 GSocketAddress * saddr;
 //int sport;
 //char name[128];//network Name of device
 //GInetAddress* iaddr;
 //char ipname[128];//network Name of device
 //int state;//0 Stop 7=play sent, 8=play confirm received
 //char ui[1024];//network Name of device
};



void * commonspinner (GCond* cond, GMutex* mutex);
gchar* gst_pad_get_pe_name(GstPad *pad);
char* deserialize_uint64 (guint64* result,const char * s);
char* deserialize_int64 (gint64* result,const char * s);
char* deserialize_double (gdouble* result,const char * s);
char* deserialize_string (char* result,const char * s);
char* deserialize_string2 (char* result,const char * s, char separator);
int swapint(int ui);
void genquat( double *w,double *x,double *y ,double *z, CvMat* rota );
#endif /* __GST_ROSCOMMON__ */
