/* GStreamer
 * Copyright (C) 2013 Hansen
 * gstmultifilesink.c:
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif



#include <gst/gst.h>


#include "gstshmsrc.h"
#include "gstshmsink.h"



static gboolean
plugin_init (GstPlugin * plugin)
{
  //gst_element_register (plugin, "multifilesrc", GST_RANK_NONE,
  //    gst_multi_file_src_get_type ());
  gst_element_register (plugin, "shmsrc", GST_RANK_NONE, GST_TYPE_SHMSRC);
  gst_element_register (plugin, "shmsink", GST_RANK_NONE,
      GST_TYPE_SHMSINK);

  return TRUE;
}

GST_PLUGIN_DEFINE (GST_VERSION_MAJOR,
    GST_VERSION_MINOR,
    "shm",
    "Exchanges Data over shared Memory regions",
    plugin_init, VERSION, "LGPL", "gst-plugins-robotix", "Hannes Bistry");
